/*	Renegade Scripts.dll
	Copyright 2011 Tiberian Technologies

	This file is part of the Renegade scripts.dll
	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
	the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2, or (at your option) any later
	version. See the file COPYING for more details.
	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
	Only the source code to the module(s) containing the licenced code has to be released.
*/
#ifndef TT_INCLUDE_BASECONTROLLERCLASS_H
#define TT_INCLUDE_BASECONTROLLERCLASS_H
#include "NetworkObjectClass.h"
#include "OBBoxClass.h"
#include "Engine_Vector.h"
#include "scripts.h"
class BuildingGameObj;
class VehicleGameObj;
class BeaconGameObj;
class BaseControllerClass :
	public NetworkObjectClass
{

private:

	float OperationTimeFactor; // 06B4
	int team; // 06B8
	DynamicVectorClass<BuildingGameObj*> BuildingList; // 06BC
	bool IsPowered; // 06D4
	bool CanGenerateSoldiers; // 06D5
	bool CanGenerateVehicles; // 06D6
	bool RadarEnabled; // 06D7
	bool BaseDestroyed; // 06D8
	bool BeaconDestroyedBase; // 06D9
	OBBoxClass BeaconZone; // 06DC
	unsigned int AnnouncementInterval; // 0718
	float AnnouncementTime; // 071C
	float AnnouncementTime2; // 0720
	unsigned int Unknown1; // 0724
	unsigned int Unknown2; // 0728

public:

	~BaseControllerClass();
	void Import_Occasional(BitStreamClass &BitStream);
	void Export_Occasional(BitStreamClass &BitStream);
	void Set_Delete_Pending()
	{
	}
	void Delete()
	{
	}
	static BaseControllerClass *Find_Base(int Team);
	VehicleGameObj *Get_Harvester_Vehicle();
	BuildingGameObj *Find_Building(unsigned int Type);
	void Power_Base(bool Power);
	void Set_Can_Generate_Soldiers(bool CanGenerate);
	void Set_Can_Generate_Vehicles(bool CanGenerate);
	void Set_Base_Destroyed(bool BaseDesrtoyed);
	void Destroy_Base();
	void Set_Beacon_Destroyed_Base(bool BeaconDestroyed);
	void Enable_Radar(bool Enable);
	void Distribute_Funds_To_Each_Teammate(int Amount);
	void Distribute_Funds_To_Each_Teammate(float Amount);
	void On_Vehicle_Generated(VehicleGameObj *);
	void On_Beacon_Warning(BeaconGameObj* beacon);
	void Request_Harvester(int harvesterDefinitionId);
	void Check_Radar();
	static BaseControllerClass *Find_Base_For_Star();
	void On_Beacon_Armed(BeaconGameObj *);
	void On_Beacon_Disarmed(BeaconGameObj *);
	void Add_Building(BuildingGameObj *b);
	void On_Building_Damaged(BuildingGameObj *);
	void On_Building_Destroyed(BuildingGameObj *);
	void On_Vehicle_Delivered(VehicleGameObj *);
	void On_Vehicle_Damaged(VehicleGameObj *);
	void On_Vehicle_Destroyed(VehicleGameObj *);
	void Check_Base_Power();
	void Check_Vehicle_Factory();
	void Play_Announcement(int announcement);
	bool Can_Build_Air();
	bool Can_Build_Ground();
	bool Can_Build_Naval();
	void Check_Prerequisites();

	bool Is_Base_Powered() const
	{
		return IsPowered;
	}
	float Get_Operation_Time_Factor() const
	{
		return OperationTimeFactor;
	}
	bool Can_Generate_Soldiers() const
	{
		return CanGenerateSoldiers;
	}
	bool Can_Generate_Vehicles() const
	{
		return CanGenerateVehicles;
	}
	int Get_Player_Type() const
	{
		return team;
	}
	bool Is_Base_Destroyed() const
	{
		return BaseDestroyed;
	}
	bool Did_Beacon_Destroy_Base() const
	{
		return BeaconDestroyedBase;
	}
	const OBBoxClass& Get_Beacon_Zone()
	{
		return BeaconZone;
	}
	bool Is_Radar_Enabled() const
	{
		return RadarEnabled;
	}
	DynamicVectorClass<BuildingGameObj*> &Get_Building_List()
	{
		return BuildingList;
	}
}; // 072C

#endif